SystemOrganization addCategory: #'PVpub-AnalogClockPrototype02'!

CircleMorph subclass: #Dial02
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype02'!

!Dial02 commentStamp: 'pv 9/15/2014 22:49' prior: 0!
A Dial02 is a dial of an analogue clock.

Instance Variables
!

!Dial02 methodsFor: 'parts bin' stamp: 'pv 9/15/2014 22:43'!
initialize
	| watchHand02 |
	super initialize.
	self extent: 200 @ 200;
		 position: 300 @ 300;
		color: Color yellow.
	watchHand02 := WatchHand02 new.
	watchHand02
		setDefaultMidnightVerticesFromCenter: self center
		andRadius: self extent x // 2
		withFraction: 0.9;
		 referencePosition: self center.
	self addMorph: watchHand02! !

PolygonMorph subclass: #WatchHand02
	instanceVariableNames: 'rotationDegrees referencePositionLag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PVpub-AnalogClockPrototype02'!

!WatchHand02 commentStamp: 'pv 9/15/2014 23:03' prior: 0!
A WatchHand02 is a watchhand of an analogue clock.

Instance Variables
	referencePositionLag:	<Point> 
	rotationDegrees:			<Float> 

referencePositionLag
	- value of referencePosition the last time step was called
	- (DisplayScreen boundingBox origin)..(DisplayScreen boundingBox corner)

rotationDegrees
	- rotation degrees with respect to midnight position
	- [0..360)
!

!WatchHand02 methodsFor: 'initialization' stamp: 'pv 5/8/2014 19:55'!
initialize
	super initialize.
	"used to recognize size changes in method step"
	referencePositionLag := 0 @ 0! !

!WatchHand02 methodsFor: 'stepping and presenter' stamp: 'pv 9/15/2014 22:47'!
pvtRotationCenterHasChangedSinceLastStep
	"no change of rotation center since last step"
	^ self referencePosition ~= referencePositionLag! !

!WatchHand02 methodsFor: 'stepping and presenter' stamp: 'pv 9/15/2014 22:47'!
pvtRotationCenterIsAlignedWithOwnersCenter
	""
	^ self referencePosition rounded = self owner center! !

!WatchHand02 methodsFor: 'initialization' stamp: 'pv 9/15/2014 22:42'!
setDefaultMidnightVerticesFromCenter: aPoint andRadius: aNumberOfPixel withFraction: aFractionFloat 
	| lozengeLengthFromCenter lozengeWidthFromCenter midnightVertices |
	lozengeLengthFromCenter := 3 max: (aNumberOfPixel * aFractionFloat) rounded.
	lozengeWidthFromCenter := 1 max: lozengeLengthFromCenter // 10.
	midnightVertices := Array
				with: aPoint + (0 @ lozengeWidthFromCenter)
				with: aPoint + (-1 * lozengeWidthFromCenter @ 0)
				with: aPoint + (0 @ -1 * lozengeLengthFromCenter)
				with: aPoint + (lozengeWidthFromCenter @ 0).
	self
		vertices: midnightVertices
		color: Color green
		borderWidth: 1
		borderColor: Color black.
	self rotationCenter: 0.5 @ (lozengeLengthFromCenter / (lozengeLengthFromCenter + lozengeWidthFromCenter))! !

!WatchHand02 methodsFor: 'stepping and presenter' stamp: 'pv 9/15/2014 22:48'!
step
	self
		assert: [self pvtRotationCenterHasChangedSinceLastStep | self pvtRotationCenterIsAlignedWithOwnersCenter].
	self rotationDegrees: self rotationDegrees + 6 \\ 360.
	referencePositionLag := self referencePosition! !

!WatchHand02 methodsFor: 'stepping and presenter' stamp: 'pv 9/15/2014 22:46'!
stepTime
	"set step time in miliseconds"
	^ 1000! !
